﻿Option Strict On
Imports System.IO.IsolatedStorage
Imports System.IO
Imports System.Xml.Linq

Partial Public Class PanoramaPage1
    Inherits PhoneApplicationPage

    Public Sub New()
        InitializeComponent()
    End Sub

    Dim delSeasonFileName As String = String.Empty
    Dim delSeasonName As String = String.Empty

    Private Sub helpDelSpringButton_Tap(sender As System.Object, e As System.Windows.Input.GestureEventArgs) Handles helpDelSpringButton.Tap
        delSeasonFileName = "spring"
        delSeasonName = "春"
        delSeasonFile()
    End Sub

    Private Sub helpDelSummerButton_Tap(sender As System.Object, e As System.Windows.Input.GestureEventArgs) Handles helpDelSummerButton.Tap
        delSeasonFileName = "summer"
        delSeasonName = "夏"
        delSeasonFile()
    End Sub

    Private Sub helpDelAutumnButton_Tap(sender As System.Object, e As System.Windows.Input.GestureEventArgs) Handles helpDelAutumnButton.Tap
        delSeasonFileName = "autumn"
        delSeasonName = "秋"
        delSeasonFile()
    End Sub

    Private Sub helpDelWinterButton_Tap(sender As System.Object, e As System.Windows.Input.GestureEventArgs) Handles helpDelWinterButton.Tap
        delSeasonFileName = "winter"
        delSeasonName = "冬"
        delSeasonFile()
    End Sub


    Private Sub delSeasonFile()

        Dim CheckRemove As MessageBoxResult = MessageBox.Show("ほんとうに削除してもよいですか？この操作を実行すると、この季節の俳句データはすべて失われます。", delSeasonName & "の俳句ファイルを削除しますか？", MessageBoxButton.OKCancel)

        Select Case CheckRemove
            Case MessageBoxResult.OK

                Dim delSeasonXml As XElement
                Dim storage As IsolatedStorageFile = IsolatedStorageFile.GetUserStoreForApplication
                Dim filePath As String = String.Empty
                filePath = Path.Combine("DailyHaikuData", delSeasonFileName & ".xml")
                If storage.DirectoryExists("DailyHaikuData") = True And storage.FileExists(filePath) = True Then
                    Dim myStream As IsolatedStorageFileStream = storage.OpenFile(filePath, FileMode.Open, FileAccess.Read)
                    Using reader As StreamReader = New StreamReader(myStream, System.Text.Encoding.UTF8)
                        Dim readDeleteXmldoc As String = reader.ReadToEnd
                        delSeasonXml = XElement.Parse(readDeleteXmldoc)
                        myStream.Close()
                    End Using

                    storage.DeleteFile(filePath)
                    MessageBox.Show(delSeasonName & "の俳句ファイルを削除しました。")
                Else
                    MessageBox.Show(delSeasonName & "の俳句ファイルはありません。")
                    Exit Sub
                End If

                Exit Select
            Case Else
                Exit Sub
        End Select

    End Sub

End Class
