﻿Option Strict On
Imports System.IO.IsolatedStorage
Imports System.IO
Imports Microsoft.Phone.Tasks
Imports System.Xml.Linq
Imports System.Text

Partial Public Class createHaiku
    Inherits PhoneApplicationPage

    Public Sub New()
        InitializeComponent()
    End Sub

    '■メインページから渡された「季節」のデータを受け取る処理
    Protected Overrides Sub OnNavigatedTo(ByVal e As System.Windows.Navigation.NavigationEventArgs)
        Dim param As IDictionary(Of String, String) = NavigationContext.QueryString
        season.Text = param("Name")
        MyBase.OnNavigatedTo(e)
    End Sub

    Dim ruby As String = String.Empty
    Dim ku As String = String.Empty
    Dim myDate As String = DateTime.Today.ToString("d")
    Dim mySeason As String = String.Empty
    Dim kigoSeason As String = String.Empty

    '■この入力ページがロードされた時の処理
    Private Sub createHaiku_Loaded(sender As Object, e As System.Windows.RoutedEventArgs) Handles MyBase.Loaded

        readHaikuButton.Opacity = 0.3

        mySeason = season.Text

        If mySeason = "spring" Then
            kigoSeason = "春"
        ElseIf mySeason = "summer" Then
            kigoSeason = "夏"
        ElseIf mySeason = "autumn" Then
            kigoSeason = "秋"
        ElseIf mySeason = "winter" Then
            kigoSeason = "冬"
        End If

        searchKigoSeasonName.Text = kigoSeason

        Dim haikuStorage As IsolatedStorageFile = IsolatedStorageFile.GetUserStoreForApplication
        Dim haikuFilePath As String = Path.Combine("DailyHaikuData", mySeason & ".xml")

        If haikuStorage.DirectoryExists("DailyHaikuData") = True And haikuStorage.FileExists(haikuFilePath) = True Then
            readHaikuButton.Opacity = 1.0
            readHaikuButton.IsEnabled = True
        End If
    End Sub

    '■「保存」ボタンがタップされた時の処理
    Private Sub saveButton_Tap(sender As System.Object, e As System.Windows.Input.GestureEventArgs) Handles saveButton.Tap

        ruby = rubyBox.Text
        ku = kuBox.Text

        Dim rubyNum As Integer = Encoding.GetEncoding("utf-8").GetByteCount(ruby)
        Dim rubyLen As Integer = ruby.Length

        Dim kuNum As Integer = Encoding.GetEncoding("utf-8").GetByteCount(ku)
        Dim kuLen As Integer = ku.Length

        If kuNum <> kuLen * 3 OrElse rubyNum <> rubyLen * 3 Then
            MessageBox.Show("全角で入力してください。")
            Exit Sub
        End If

        If ku <> String.Empty Then

            Try
                Dim storage As IsolatedStorageFile = IsolatedStorageFile.GetUserStoreForApplication
                If storage.DirectoryExists("DailyHaikuData") = False Then
                    storage.CreateDirectory("DailyHaikuData")
                End If

                Dim filePath As String = Path.Combine("DailyHaikuData", mySeason & ".xml")


                If storage.FileExists(filePath) = False Then
                    Dim xmldoc As XDocument = <?xml version="1.0" encoding="utf-8"?>
                                              <俳句集 季節=<%= kigoSeason %>>
                                                  <俳句 日時=<%= myDate %>>
                                                      <ルビ><%= ruby %></ルビ>
                                                      <句><%= ku %></句>
                                                  </俳句>
                                              </俳句集>
                    Using myStream As IsolatedStorageFileStream = New IsolatedStorageFileStream(filePath, FileMode.Create, FileAccess.Write, storage)
                        xmldoc.Save(myStream)
                        MessageBox.Show("今日の俳句を保存しました。")

                    End Using

                Else

                    Dim addStream As IsolatedStorageFileStream = storage.OpenFile(filePath, FileMode.Open, FileAccess.Read)
                    Dim reader As StreamReader = New StreamReader(addStream)
                    Dim readXmldoc As String = reader.ReadToEnd
                    Dim addDoc As XElement = XElement.Parse(readXmldoc)
                    Dim addXml As XElement = <俳句 日時=<%= myDate %>>
                                                 <ルビ><%= ruby %></ルビ>
                                                 <句><%= ku %></句>
                                             </俳句>
                    addDoc.Add(addXml)
                    addStream.Dispose()

                    Using stream As IsolatedStorageFileStream = New IsolatedStorageFileStream(filePath, FileMode.Create, FileAccess.Write, storage)
                        If storage.FileExists(filePath) = True Then
                            addDoc.Save(stream)
                            reader.Dispose()
                            MessageBox.Show("今日の俳句を保存しました。")
                        End If
                    End Using
                End If

                rubyBox.Text = String.Empty
                kuBox.Text = String.Empty

                readHaikuButton.Opacity = 1.0
                readHaikuButton.IsEnabled = True
            Catch
                Exit Sub
            End Try
        Else
            MessageBox.Show("俳句を入力してください。")
            Exit Sub
        End If

    End Sub

    '■「一覧」ボタンがタップされた時の処理
    Private Sub readHaikuButton_Tap(sender As System.Object, e As System.Windows.Input.GestureEventArgs) Handles readHaikuButton.Tap
        NavigationService.Navigate(New Uri("/haikuShow.xaml?Name=" & mySeason, UriKind.Relative))
    End Sub

    '■「季語検索」ボタンがタップされた時の処理
    Private Sub searchKigo_Tap(sender As System.Object, e As System.Windows.Input.GestureEventArgs) Handles searchKigo.Tap
        Dim myTask As New SearchTask
        myTask.SearchQuery = kigoSeason & " 季語"
        myTask.Show()
    End Sub

    '■「季節選択」ボタンがタップされた時の処理
    Private Sub selectSeasonButton_Tap(sender As System.Object, e As System.Windows.Input.GestureEventArgs) Handles selectSeasonButton.Tap
        NavigationService.Navigate(New Uri("/MainPage.xaml?home=true", UriKind.Relative))
    End Sub

End Class
